// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: additionalTypes/decimal.proto

package additionalTypes;

public final class Decimals {
  private Decimals() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistryLite registry) {
  }

  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
    registerAllExtensions(
        (com.google.protobuf.ExtensionRegistryLite) registry);
  }
  public interface DecimalOrBuilder extends
      // @@protoc_insertion_point(interface_extends:additionalTypes.Decimal)
      com.google.protobuf.MessageOrBuilder {

    /**
     * <pre>
     * The whole units of the Decimal.
     * This has to be a whole positive or negative or zero
     * Ex: Units for -89.567800 will be -89
     * </pre>
     *
     * <code>int64 units = 1;</code>
     * @return The units.
     */
    long getUnits();

    /**
     * <pre>
     * Number of nano (10^9) units of the amount.
     * The value must be between -999,999,999 and +999,999,999 inclusive.
     * If `units` is positive, `fraction` must be positive or zero.
     * If `units` is zero, `fraction` can be positive, zero, or negative.
     * If `units` is negative, `fraction` must be negative or zero.
     * Ex: -89.5678000 is represented as `units`=-89 and `fraction`=-567,800,000 (-0.567800 * 10^9)
     * </pre>
     *
     * <code>int32 fraction = 2;</code>
     * @return The fraction.
     */
    int getFraction();

    /**
     * <pre>
     * Represents the precision for the Decimal
     * Precision can only be a positive integer.
     * Ex: -89.567800 has precision of 8
     * </pre>
     *
     * <code>uint32 precision = 3;</code>
     * @return The precision.
     */
    int getPrecision();

    /**
     * <pre>
     * Represents the scale for the Decimal
     * Scale can be positive, zero or negative.
     * Ex: -89.567800 has scale of 6
     * -89.567800 represented with scale=0 is -89
     * -89.567800 represented with scale=-1 is -80
     * </pre>
     *
     * <code>int32 scale = 4;</code>
     * @return The scale.
     */
    int getScale();
  }
  /**
   * <pre>
   * Protobuf standard library / WellKnownTypes don't provide a Decimal type.
   * This posses a challenge to represent Decimals that cannot be accurately represented
   * using float or double types.
   * Related issue: https://github.com/protocolbuffers/protobuf/issues/4406
   * </pre>
   *
   * Protobuf type {@code additionalTypes.Decimal}
   */
  public static final class Decimal extends
      com.google.protobuf.GeneratedMessageV3 implements
      // @@protoc_insertion_point(message_implements:additionalTypes.Decimal)
      DecimalOrBuilder {
  private static final long serialVersionUID = 0L;
    // Use Decimal.newBuilder() to construct.
    private Decimal(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
      super(builder);
    }
    private Decimal() {
    }

    @java.lang.Override
    @SuppressWarnings({"unused"})
    protected java.lang.Object newInstance(
        UnusedPrivateParameter unused) {
      return new Decimal();
    }

    @java.lang.Override
    public final com.google.protobuf.UnknownFieldSet
    getUnknownFields() {
      return this.unknownFields;
    }
    private Decimal(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      this();
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder();
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 8: {

              units_ = input.readInt64();
              break;
            }
            case 16: {

              fraction_ = input.readInt32();
              break;
            }
            case 24: {

              precision_ = input.readUInt32();
              break;
            }
            case 32: {

              scale_ = input.readInt32();
              break;
            }
            default: {
              if (!parseUnknownField(
                  input, unknownFields, extensionRegistry, tag)) {
                done = true;
              }
              break;
            }
          }
        }
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(this);
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(this);
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(
            e).setUnfinishedMessage(this);
      } finally {
        this.unknownFields = unknownFields.build();
        makeExtensionsImmutable();
      }
    }
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return additionalTypes.Decimals.internal_static_additionalTypes_Decimal_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return additionalTypes.Decimals.internal_static_additionalTypes_Decimal_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              additionalTypes.Decimals.Decimal.class, additionalTypes.Decimals.Decimal.Builder.class);
    }

    public static final int UNITS_FIELD_NUMBER = 1;
    private long units_;
    /**
     * <pre>
     * The whole units of the Decimal.
     * This has to be a whole positive or negative or zero
     * Ex: Units for -89.567800 will be -89
     * </pre>
     *
     * <code>int64 units = 1;</code>
     * @return The units.
     */
    @java.lang.Override
    public long getUnits() {
      return units_;
    }

    public static final int FRACTION_FIELD_NUMBER = 2;
    private int fraction_;
    /**
     * <pre>
     * Number of nano (10^9) units of the amount.
     * The value must be between -999,999,999 and +999,999,999 inclusive.
     * If `units` is positive, `fraction` must be positive or zero.
     * If `units` is zero, `fraction` can be positive, zero, or negative.
     * If `units` is negative, `fraction` must be negative or zero.
     * Ex: -89.5678000 is represented as `units`=-89 and `fraction`=-567,800,000 (-0.567800 * 10^9)
     * </pre>
     *
     * <code>int32 fraction = 2;</code>
     * @return The fraction.
     */
    @java.lang.Override
    public int getFraction() {
      return fraction_;
    }

    public static final int PRECISION_FIELD_NUMBER = 3;
    private int precision_;
    /**
     * <pre>
     * Represents the precision for the Decimal
     * Precision can only be a positive integer.
     * Ex: -89.567800 has precision of 8
     * </pre>
     *
     * <code>uint32 precision = 3;</code>
     * @return The precision.
     */
    @java.lang.Override
    public int getPrecision() {
      return precision_;
    }

    public static final int SCALE_FIELD_NUMBER = 4;
    private int scale_;
    /**
     * <pre>
     * Represents the scale for the Decimal
     * Scale can be positive, zero or negative.
     * Ex: -89.567800 has scale of 6
     * -89.567800 represented with scale=0 is -89
     * -89.567800 represented with scale=-1 is -80
     * </pre>
     *
     * <code>int32 scale = 4;</code>
     * @return The scale.
     */
    @java.lang.Override
    public int getScale() {
      return scale_;
    }

    private byte memoizedIsInitialized = -1;
    @java.lang.Override
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized == 1) return true;
      if (isInitialized == 0) return false;

      memoizedIsInitialized = 1;
      return true;
    }

    @java.lang.Override
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      if (units_ != 0L) {
        output.writeInt64(1, units_);
      }
      if (fraction_ != 0) {
        output.writeInt32(2, fraction_);
      }
      if (precision_ != 0) {
        output.writeUInt32(3, precision_);
      }
      if (scale_ != 0) {
        output.writeInt32(4, scale_);
      }
      unknownFields.writeTo(output);
    }

    @java.lang.Override
    public int getSerializedSize() {
      int size = memoizedSize;
      if (size != -1) return size;

      size = 0;
      if (units_ != 0L) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, units_);
      }
      if (fraction_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, fraction_);
      }
      if (precision_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeUInt32Size(3, precision_);
      }
      if (scale_ != 0) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(4, scale_);
      }
      size += unknownFields.getSerializedSize();
      memoizedSize = size;
      return size;
    }

    @java.lang.Override
    public boolean equals(final java.lang.Object obj) {
      if (obj == this) {
       return true;
      }
      if (!(obj instanceof additionalTypes.Decimals.Decimal)) {
        return super.equals(obj);
      }
      additionalTypes.Decimals.Decimal other = (additionalTypes.Decimals.Decimal) obj;

      if (getUnits()
          != other.getUnits()) return false;
      if (getFraction()
          != other.getFraction()) return false;
      if (getPrecision()
          != other.getPrecision()) return false;
      if (getScale()
          != other.getScale()) return false;
      if (!unknownFields.equals(other.unknownFields)) return false;
      return true;
    }

    @java.lang.Override
    public int hashCode() {
      if (memoizedHashCode != 0) {
        return memoizedHashCode;
      }
      int hash = 41;
      hash = (19 * hash) + getDescriptor().hashCode();
      hash = (37 * hash) + UNITS_FIELD_NUMBER;
      hash = (53 * hash) + com.google.protobuf.Internal.hashLong(
          getUnits());
      hash = (37 * hash) + FRACTION_FIELD_NUMBER;
      hash = (53 * hash) + getFraction();
      hash = (37 * hash) + PRECISION_FIELD_NUMBER;
      hash = (53 * hash) + getPrecision();
      hash = (37 * hash) + SCALE_FIELD_NUMBER;
      hash = (53 * hash) + getScale();
      hash = (29 * hash) + unknownFields.hashCode();
      memoizedHashCode = hash;
      return hash;
    }

    public static additionalTypes.Decimals.Decimal parseFrom(
        java.nio.ByteBuffer data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        java.nio.ByteBuffer data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return PARSER.parseFrom(data, extensionRegistry);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }
    public static additionalTypes.Decimals.Decimal parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input);
    }
    public static additionalTypes.Decimals.Decimal parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input);
    }
    public static additionalTypes.Decimals.Decimal parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return com.google.protobuf.GeneratedMessageV3
          .parseWithIOException(PARSER, input, extensionRegistry);
    }

    @java.lang.Override
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder() {
      return DEFAULT_INSTANCE.toBuilder();
    }
    public static Builder newBuilder(additionalTypes.Decimals.Decimal prototype) {
      return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
    }
    @java.lang.Override
    public Builder toBuilder() {
      return this == DEFAULT_INSTANCE
          ? new Builder() : new Builder().mergeFrom(this);
    }

    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    /**
     * <pre>
     * Protobuf standard library / WellKnownTypes don't provide a Decimal type.
     * This posses a challenge to represent Decimals that cannot be accurately represented
     * using float or double types.
     * Related issue: https://github.com/protocolbuffers/protobuf/issues/4406
     * </pre>
     *
     * Protobuf type {@code additionalTypes.Decimal}
     */
    public static final class Builder extends
        com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
        // @@protoc_insertion_point(builder_implements:additionalTypes.Decimal)
        additionalTypes.Decimals.DecimalOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return additionalTypes.Decimals.internal_static_additionalTypes_Decimal_descriptor;
      }

      @java.lang.Override
      protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return additionalTypes.Decimals.internal_static_additionalTypes_Decimal_fieldAccessorTable
            .ensureFieldAccessorsInitialized(
                additionalTypes.Decimals.Decimal.class, additionalTypes.Decimals.Decimal.Builder.class);
      }

      // Construct using additionalTypes.Decimals.Decimal.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }

      private Builder(
          com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessageV3
                .alwaysUseFieldBuilders) {
        }
      }
      @java.lang.Override
      public Builder clear() {
        super.clear();
        units_ = 0L;

        fraction_ = 0;

        precision_ = 0;

        scale_ = 0;

        return this;
      }

      @java.lang.Override
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return additionalTypes.Decimals.internal_static_additionalTypes_Decimal_descriptor;
      }

      @java.lang.Override
      public additionalTypes.Decimals.Decimal getDefaultInstanceForType() {
        return additionalTypes.Decimals.Decimal.getDefaultInstance();
      }

      @java.lang.Override
      public additionalTypes.Decimals.Decimal build() {
        additionalTypes.Decimals.Decimal result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }

      @java.lang.Override
      public additionalTypes.Decimals.Decimal buildPartial() {
        additionalTypes.Decimals.Decimal result = new additionalTypes.Decimals.Decimal(this);
        result.units_ = units_;
        result.fraction_ = fraction_;
        result.precision_ = precision_;
        result.scale_ = scale_;
        onBuilt();
        return result;
      }

      @java.lang.Override
      public Builder clone() {
        return super.clone();
      }
      @java.lang.Override
      public Builder setField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.setField(field, value);
      }
      @java.lang.Override
      public Builder clearField(
          com.google.protobuf.Descriptors.FieldDescriptor field) {
        return super.clearField(field);
      }
      @java.lang.Override
      public Builder clearOneof(
          com.google.protobuf.Descriptors.OneofDescriptor oneof) {
        return super.clearOneof(oneof);
      }
      @java.lang.Override
      public Builder setRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          int index, java.lang.Object value) {
        return super.setRepeatedField(field, index, value);
      }
      @java.lang.Override
      public Builder addRepeatedField(
          com.google.protobuf.Descriptors.FieldDescriptor field,
          java.lang.Object value) {
        return super.addRepeatedField(field, value);
      }
      @java.lang.Override
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof additionalTypes.Decimals.Decimal) {
          return mergeFrom((additionalTypes.Decimals.Decimal)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }

      public Builder mergeFrom(additionalTypes.Decimals.Decimal other) {
        if (other == additionalTypes.Decimals.Decimal.getDefaultInstance()) return this;
        if (other.getUnits() != 0L) {
          setUnits(other.getUnits());
        }
        if (other.getFraction() != 0) {
          setFraction(other.getFraction());
        }
        if (other.getPrecision() != 0) {
          setPrecision(other.getPrecision());
        }
        if (other.getScale() != 0) {
          setScale(other.getScale());
        }
        this.mergeUnknownFields(other.unknownFields);
        onChanged();
        return this;
      }

      @java.lang.Override
      public final boolean isInitialized() {
        return true;
      }

      @java.lang.Override
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        additionalTypes.Decimals.Decimal parsedMessage = null;
        try {
          parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
        } catch (com.google.protobuf.InvalidProtocolBufferException e) {
          parsedMessage = (additionalTypes.Decimals.Decimal) e.getUnfinishedMessage();
          throw e.unwrapIOException();
        } finally {
          if (parsedMessage != null) {
            mergeFrom(parsedMessage);
          }
        }
        return this;
      }

      private long units_ ;
      /**
       * <pre>
       * The whole units of the Decimal.
       * This has to be a whole positive or negative or zero
       * Ex: Units for -89.567800 will be -89
       * </pre>
       *
       * <code>int64 units = 1;</code>
       * @return The units.
       */
      @java.lang.Override
      public long getUnits() {
        return units_;
      }
      /**
       * <pre>
       * The whole units of the Decimal.
       * This has to be a whole positive or negative or zero
       * Ex: Units for -89.567800 will be -89
       * </pre>
       *
       * <code>int64 units = 1;</code>
       * @param value The units to set.
       * @return This builder for chaining.
       */
      public Builder setUnits(long value) {
        
        units_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * The whole units of the Decimal.
       * This has to be a whole positive or negative or zero
       * Ex: Units for -89.567800 will be -89
       * </pre>
       *
       * <code>int64 units = 1;</code>
       * @return This builder for chaining.
       */
      public Builder clearUnits() {
        
        units_ = 0L;
        onChanged();
        return this;
      }

      private int fraction_ ;
      /**
       * <pre>
       * Number of nano (10^9) units of the amount.
       * The value must be between -999,999,999 and +999,999,999 inclusive.
       * If `units` is positive, `fraction` must be positive or zero.
       * If `units` is zero, `fraction` can be positive, zero, or negative.
       * If `units` is negative, `fraction` must be negative or zero.
       * Ex: -89.5678000 is represented as `units`=-89 and `fraction`=-567,800,000 (-0.567800 * 10^9)
       * </pre>
       *
       * <code>int32 fraction = 2;</code>
       * @return The fraction.
       */
      @java.lang.Override
      public int getFraction() {
        return fraction_;
      }
      /**
       * <pre>
       * Number of nano (10^9) units of the amount.
       * The value must be between -999,999,999 and +999,999,999 inclusive.
       * If `units` is positive, `fraction` must be positive or zero.
       * If `units` is zero, `fraction` can be positive, zero, or negative.
       * If `units` is negative, `fraction` must be negative or zero.
       * Ex: -89.5678000 is represented as `units`=-89 and `fraction`=-567,800,000 (-0.567800 * 10^9)
       * </pre>
       *
       * <code>int32 fraction = 2;</code>
       * @param value The fraction to set.
       * @return This builder for chaining.
       */
      public Builder setFraction(int value) {
        
        fraction_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Number of nano (10^9) units of the amount.
       * The value must be between -999,999,999 and +999,999,999 inclusive.
       * If `units` is positive, `fraction` must be positive or zero.
       * If `units` is zero, `fraction` can be positive, zero, or negative.
       * If `units` is negative, `fraction` must be negative or zero.
       * Ex: -89.5678000 is represented as `units`=-89 and `fraction`=-567,800,000 (-0.567800 * 10^9)
       * </pre>
       *
       * <code>int32 fraction = 2;</code>
       * @return This builder for chaining.
       */
      public Builder clearFraction() {
        
        fraction_ = 0;
        onChanged();
        return this;
      }

      private int precision_ ;
      /**
       * <pre>
       * Represents the precision for the Decimal
       * Precision can only be a positive integer.
       * Ex: -89.567800 has precision of 8
       * </pre>
       *
       * <code>uint32 precision = 3;</code>
       * @return The precision.
       */
      @java.lang.Override
      public int getPrecision() {
        return precision_;
      }
      /**
       * <pre>
       * Represents the precision for the Decimal
       * Precision can only be a positive integer.
       * Ex: -89.567800 has precision of 8
       * </pre>
       *
       * <code>uint32 precision = 3;</code>
       * @param value The precision to set.
       * @return This builder for chaining.
       */
      public Builder setPrecision(int value) {
        
        precision_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Represents the precision for the Decimal
       * Precision can only be a positive integer.
       * Ex: -89.567800 has precision of 8
       * </pre>
       *
       * <code>uint32 precision = 3;</code>
       * @return This builder for chaining.
       */
      public Builder clearPrecision() {
        
        precision_ = 0;
        onChanged();
        return this;
      }

      private int scale_ ;
      /**
       * <pre>
       * Represents the scale for the Decimal
       * Scale can be positive, zero or negative.
       * Ex: -89.567800 has scale of 6
       * -89.567800 represented with scale=0 is -89
       * -89.567800 represented with scale=-1 is -80
       * </pre>
       *
       * <code>int32 scale = 4;</code>
       * @return The scale.
       */
      @java.lang.Override
      public int getScale() {
        return scale_;
      }
      /**
       * <pre>
       * Represents the scale for the Decimal
       * Scale can be positive, zero or negative.
       * Ex: -89.567800 has scale of 6
       * -89.567800 represented with scale=0 is -89
       * -89.567800 represented with scale=-1 is -80
       * </pre>
       *
       * <code>int32 scale = 4;</code>
       * @param value The scale to set.
       * @return This builder for chaining.
       */
      public Builder setScale(int value) {
        
        scale_ = value;
        onChanged();
        return this;
      }
      /**
       * <pre>
       * Represents the scale for the Decimal
       * Scale can be positive, zero or negative.
       * Ex: -89.567800 has scale of 6
       * -89.567800 represented with scale=0 is -89
       * -89.567800 represented with scale=-1 is -80
       * </pre>
       *
       * <code>int32 scale = 4;</code>
       * @return This builder for chaining.
       */
      public Builder clearScale() {
        
        scale_ = 0;
        onChanged();
        return this;
      }
      @java.lang.Override
      public final Builder setUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.setUnknownFields(unknownFields);
      }

      @java.lang.Override
      public final Builder mergeUnknownFields(
          final com.google.protobuf.UnknownFieldSet unknownFields) {
        return super.mergeUnknownFields(unknownFields);
      }


      // @@protoc_insertion_point(builder_scope:additionalTypes.Decimal)
    }

    // @@protoc_insertion_point(class_scope:additionalTypes.Decimal)
    private static final additionalTypes.Decimals.Decimal DEFAULT_INSTANCE;
    static {
      DEFAULT_INSTANCE = new additionalTypes.Decimals.Decimal();
    }

    public static additionalTypes.Decimals.Decimal getDefaultInstance() {
      return DEFAULT_INSTANCE;
    }

    private static final com.google.protobuf.Parser<Decimal>
        PARSER = new com.google.protobuf.AbstractParser<Decimal>() {
      @java.lang.Override
      public Decimal parsePartialFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return new Decimal(input, extensionRegistry);
      }
    };

    public static com.google.protobuf.Parser<Decimal> parser() {
      return PARSER;
    }

    @java.lang.Override
    public com.google.protobuf.Parser<Decimal> getParserForType() {
      return PARSER;
    }

    @java.lang.Override
    public additionalTypes.Decimals.Decimal getDefaultInstanceForType() {
      return DEFAULT_INSTANCE;
    }

  }

  private static final com.google.protobuf.Descriptors.Descriptor
    internal_static_additionalTypes_Decimal_descriptor;
  private static final 
    com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internal_static_additionalTypes_Decimal_fieldAccessorTable;

  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static  com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\035additionalTypes/decimal.proto\022\017additio" +
      "nalTypes\"L\n\007Decimal\022\r\n\005units\030\001 \001(\003\022\020\n\010fr" +
      "action\030\002 \001(\005\022\021\n\tprecision\030\003 \001(\r\022\r\n\005scale" +
      "\030\004 \001(\005B\033\n\017additionalTypesB\010Decimalsb\006pro" +
      "to3"
    };
    descriptor = com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        });
    internal_static_additionalTypes_Decimal_descriptor =
      getDescriptor().getMessageTypes().get(0);
    internal_static_additionalTypes_Decimal_fieldAccessorTable = new
      com.google.protobuf.GeneratedMessageV3.FieldAccessorTable(
        internal_static_additionalTypes_Decimal_descriptor,
        new java.lang.String[] { "Units", "Fraction", "Precision", "Scale", });
  }

  // @@protoc_insertion_point(outer_class_scope)
}
